package com.bffmedia.hour10app;

import com.bffmedia.hour10app.R;

import android.app.ActionBar;
import android.app.Activity;
import android.app.FragmentTransaction;
import android.app.ActionBar.Tab;
import android.os.Bundle;

import android.view.Menu;

public class MainActivity extends Activity {


	Tab mTab1;
	Tab mTab2;
	Tab mTab3;
	Tab mTab4;
	Tab mTab5;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		
		
		ActionBar actionBar = getActionBar();		
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
		mTab1= actionBar.newTab().setText("List").setTabListener(new NavTabListener());
		mTab2= actionBar.newTab().setText("Grid").setTabListener(new NavTabListener());
		mTab3= actionBar.newTab().setText("Gallery").setTabListener(new NavTabListener());
		mTab4= actionBar.newTab().setText("Flipper").setTabListener(new NavTabListener());
		mTab5= actionBar.newTab().setText("Custom").setTabListener(new NavTabListener());

		actionBar.addTab(mTab1);
		actionBar.addTab(mTab2);
		actionBar.addTab(mTab3);
		actionBar.addTab(mTab4);
		actionBar.addTab(mTab5);
		
		showList();
		}
	
	public void showList(){
		SimpleListFragment fragmentA = new SimpleListFragment();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentA);
		ft.addToBackStack("fragment a");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	

	}
	
	public void showGrid(){
		SimpleGridFragment fragmentB = new SimpleGridFragment();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentB);
		ft.addToBackStack("fragment b");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	}

	
	public void showGallery(){
		SimpleGalleryFragment fragmentC = new SimpleGalleryFragment();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentC);
		ft.addToBackStack("gallery");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	}
	
	public void showFlipper(){
		SimpleFlipperFragment fragmentD = new SimpleFlipperFragment();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentD);
		ft.addToBackStack("flipper");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	}
	
	public void showCustomList(){
		CustomListFragment fragmentE = new CustomListFragment();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentE);
		ft.addToBackStack("custom");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	}


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}
	
	private class NavTabListener implements ActionBar.TabListener {
		public NavTabListener() {
		}
		@Override
		public void onTabReselected(Tab tab, FragmentTransaction ft) {
		}
		@Override
		public void onTabSelected(Tab tab, FragmentTransaction ft) {
			if (tab.equals(mTab1)){
				showList();
			}else if (tab.equals (mTab2)){
				showGrid();
			}else if (tab.equals (mTab3)){
				showGallery();
			}
			else if (tab.equals (mTab4)){
				showFlipper();
			}
			else if (tab.equals (mTab5)){
				showCustomList();
			}
		}
		@Override
		public void onTabUnselected(Tab tab, FragmentTransaction ft) {
		}
	}

}
