package com.bffmedia.hour13app;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import android.app.Fragment;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
public class ImageViewFragment extends Fragment   {
	ImageView mImageView;
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle b = this.getArguments();
		String url = null;
		if (b!=null){
			url=b.getString("URL");	     	
		}
		if (url!=null){
			LoadImage li = new LoadImage(mImageView,url );
			li.execute();
			}
	}
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		mImageView  = (ImageView) inflater.inflate(R.layout.image_fragment, container, false);
		return mImageView;
	}
	private class LoadImage extends AsyncTask<String , String , Long > {
		ImageView mImageView;
		String  mImageString;
		Bitmap mBitmap;

		public LoadImage (ImageView v, String imageString){
			mImageView =v;
			mImageString = imageString;
		}
		@Override
		protected void onPostExecute(Long result) {
			if (result==0){
				mImageView.setImageBitmap(mBitmap);
			}
		}
		@Override
		protected Long doInBackground(String... params) {
			String imageFileName = mImageString.replace(":", "");
			imageFileName =imageFileName.replace("/", "");
			imageFileName =imageFileName.replace(".", "");
			File imageFile = new File(getActivity().getCacheDir(), imageFileName);
			OutputStream imageOS;
			if (imageFile.exists()){
				mBitmap = BitmapFactory.decodeFile(imageFile.getAbsolutePath());
				return 0l;
			}			
			try {
				imageFile.createNewFile();
				URL imageUrl = new URL(mImageString);
				URLConnection connection = imageUrl.openConnection();
				connection.connect();
				InputStream is = connection.getInputStream();
				mBitmap = BitmapFactory.decodeStream(is);
				imageOS = new BufferedOutputStream(new FileOutputStream(imageFile));
				mBitmap.compress(Bitmap.CompressFormat.JPEG, 100, imageOS);
				imageOS.flush();
				imageOS.close();
				return (0l);
			} catch (MalformedURLException e) {
				e.printStackTrace();
				return (1l);
			} 
			catch (IOException e) {
				e.printStackTrace();
				return (1l);
			}
		}

	}
}
