package com.bffmedia.hour15appCustomAdapter;


import android.app.ListFragment;
import android.content.Context;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
public class SimpleListFragment extends ListFragment    {
	String[] mPies;
	
	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Resources resources = getResources();
		mPies = resources.getStringArray(R.array.pie_array);
		PieAdapter adapter = new PieAdapter(getActivity(), mPies);
		setListAdapter(adapter);
	}
	@Override
	public void onListItemClick(ListView l, View v, int position, long id) {
		Toast.makeText(this.getActivity().getApplicationContext(), mPies[position], Toast.LENGTH_SHORT).show();
	}
	

    public class PieAdapter extends BaseAdapter {
    Context mContext;
    String mPies[];
    LayoutInflater mInflater;
        public PieAdapter(Context c, String[] pies) {
            mContext = c;
            mPies = pies;
            mInflater = (LayoutInflater) mContext.getSystemService(
    				Context.LAYOUT_INFLATER_SERVICE);
            
        }
        public int getCount() {            
            return  mPies.length;
        }
        public Object getItem(int position) {
            return mPies[position];
        }
        public long getItemId(int position) {
            return position;
        }
        public View getView(int position, View convertView, ViewGroup parent) {
        	
//        	View view = mInflater.inflate(R.layout.list_item, null);
//        	TextView textView = (TextView) view.findViewById(R.id.pieTextView);
//        	textView.setText(mPies[position]);
//        	return view;
        	
        	ViewHolder viewHolder;
            if (convertView == null) {
                convertView = mInflater.inflate(R.layout.list_item, null);
                viewHolder = new ViewHolder();
                viewHolder.textView = (TextView) convertView.findViewById(R.id.pieTextView);
                convertView.setTag(viewHolder);
            } else {
            	viewHolder = (ViewHolder) convertView.getTag();
            }
            viewHolder.textView.setText(mPies[position]);
            return convertView;
        }
    }

    private static class ViewHolder {
        public TextView textView;
    }
} 


