package com.bffmedia.hour16app;

import java.io.FileNotFoundException;
import java.io.InputStream;




import android.app.Fragment;
import android.app.LoaderManager.LoaderCallbacks;
import android.content.ContentValues;
import android.content.CursorLoader;
import android.content.Loader;
import android.database.ContentObserver;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;


public class ImageViewFragment extends Fragment implements LoaderCallbacks<Cursor>  {
	ImageView mImageView;
	TextView mTitleView;
	Button mFavoriteButton;
	String mPhotoId=null;
	Bitmap mBitmap;
	FlickrPhoto mCurrentPhoto;

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		Bundle b = this.getArguments();	
		getLoaderManager().initLoader(0, b, this);

	}

	class PhotoContentObserver extends ContentObserver { 
	    public PhotoContentObserver(Handler handler) { 
	        super(handler); 
	    }
	    
	    @Override
	    public void onChange(boolean selfChange) {
	        InputStream is;
	        try {
	        	if (ImageViewFragment.this.isAdded()){
	        		is = getActivity().getContentResolver().openInputStream(Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mPhotoId));
	        		mBitmap =  BitmapFactory.decodeStream(is);
					mImageView.setImageBitmap(mBitmap);
	        	}
			} catch (FileNotFoundException e) {
			}
	    }
	}
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View v = inflater.inflate(R.layout.image_fragment, container, false);
		mImageView  = (ImageView) v.findViewById(R.id.imageView);
		mTitleView  = (TextView) v.findViewById(R.id.titleTextView);
		mFavoriteButton  = (Button) v.findViewById(R.id.favoriteButton);
		mFavoriteButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
            	Log.d ("image", "in onclick");
      
        		
        		 ContentValues newValues = new ContentValues();
					if (mCurrentPhoto.id!=null)
						newValues.put("flickr_id", mCurrentPhoto.id);	
					if (mCurrentPhoto.owner!=null)
						newValues.put("owner", mCurrentPhoto.owner);	
					if (mCurrentPhoto.secret!=null)
						newValues.put("secret", mCurrentPhoto.secret);	
					if (mCurrentPhoto.server!=null)
						newValues.put("server", mCurrentPhoto.server);	
					if (mCurrentPhoto.farm!=null)
						newValues.put("farm", mCurrentPhoto.farm);	
					if (mCurrentPhoto.title!=null)
						newValues.put("title", mCurrentPhoto.title);	
					if (mCurrentPhoto.isPublic!=null)
						newValues.put("isPublic", mCurrentPhoto.isPublic);	
					if (mCurrentPhoto.isFriend!=null)
						newValues.put("isFriend", mCurrentPhoto.isFriend);	
					if (mCurrentPhoto.isFamily!=null)
						newValues.put("isFamily", mCurrentPhoto.isFamily);	

			  		if (mCurrentPhoto.isFavorite){
			  			newValues.put("isFavorite", 0);
	        			mFavoriteButton.setText("Add to Favorites");
	        		}else{
	        			newValues.put("isFavorite", 1);
	        			mFavoriteButton.setText("Remove from Favorites");
	        		}
			  		int id = getActivity().getContentResolver().update(
							FlickrPhotoProvider.CONTENT_URI, 
							newValues, "flickr_id='"+mCurrentPhoto.id+"'", null);
			      	Log.d ("image", "result " + id);
            }
    });

		return v;
	}
	
	@Override
	public Loader<Cursor> onCreateLoader(int id, Bundle args) {
		if (args!=null){  
		mPhotoId=args.getString("PHOTO_ID");	
		CursorLoader cursorLoader = new CursorLoader(getActivity(),
				 Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mPhotoId), 
				null, null, null, null);		
	
	return cursorLoader;
	    }
		return null;
		
			 
	}

	@Override
	public void onLoadFinished(Loader<Cursor> loader, Cursor cursor) {
		mCurrentPhoto = FlickrPhotoDbAdapter.getPhotoFromCursor(cursor);
		mTitleView.setText(mCurrentPhoto.title +"---"+mCurrentPhoto.id);
		if (mCurrentPhoto.isFavorite){
			mFavoriteButton.setText("Remove from Favorites");
		}else{
			mFavoriteButton.setText("Add to Favorites");
		}
		

		Handler handler = new Handler();		
	    InputStream is;
		try {
			is = getActivity().getContentResolver().openInputStream(Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mPhotoId));
			mBitmap =  BitmapFactory.decodeStream(is);
			mImageView.setImageBitmap(mBitmap);
		} catch (FileNotFoundException e) {
			getActivity().getContentResolver().registerContentObserver(Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mPhotoId), false, new PhotoContentObserver(handler)); 
		}	
	}

	@Override
	public void onLoaderReset(Loader<Cursor> loader) {
	}
	
}
