package com.bffmedia.hour16app;

import android.content.Context;
import android.database.Cursor;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class ListCursorAdapter extends CursorAdapter {
	Context mContext;
	ViewGroup mViewGroup;
	private Boolean flinging = false;
	
	public ListCursorAdapter(Context context, Cursor c, int flags, ViewGroup viewGroup) {
		super(context, c, flags);
		mContext = context;
		mViewGroup = viewGroup;
	}
	public Boolean getFlinging() {
		return flinging;
	}
	public void setFlinging(Boolean flinging) {
		this.flinging = flinging;
	}	
	@Override
	public void bindView(View v, Context context, Cursor c) {
		ListViewHolder vh = (ListViewHolder) v.getTag();
		FlickrPhoto currentPhoto = FlickrPhotoDbAdapter.getPhotoFromCursor(c);
		vh.titleTextView.setText(currentPhoto.title);
		if (!flinging){
		    vh.photoImageView.setImageResource(R.drawable.imageholder);
			vh.id = currentPhoto.id;
			v.setTag(vh);
			vh.photoImageView.setTag(currentPhoto.id);
			LoadBitmapTask task = new LoadBitmapTask(mContext, mViewGroup, currentPhoto);
			task.execute();
		}else{
			vh.photoImageView.setImageResource(R.drawable.imageholder);
		}
	}
	@Override
	public View newView(Context context, Cursor cursor, ViewGroup parent) {
		LayoutInflater li = (LayoutInflater) mContext.getSystemService(
				Context.LAYOUT_INFLATER_SERVICE);
		View v = li.inflate(R.layout.list_item, parent, false);
		ListViewHolder viewHolder = new ListViewHolder();
		viewHolder.photoImageView =  (ImageView) v.findViewById(R.id.photoImageView);
		viewHolder.titleTextView = (TextView) v.findViewById(R.id.titleTextView);
		v.setTag(viewHolder);
		return (v);
	}
	public static class ListViewHolder {
		String id;
		ImageView photoImageView;
		TextView titleTextView;
	}
	

}


