package com.bffmedia.hour16app;

import java.io.FileNotFoundException;
import java.io.InputStream;

import android.content.Context;
import android.database.ContentObserver;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Handler;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;



class LoadBitmapTask extends AsyncTask {
	FlickrPhoto mPhoto;
	Handler mHandler = new Handler();
	Context mContext;
	ViewGroup mViewGroup;
		public LoadBitmapTask(Context context, ViewGroup viewGroup, FlickrPhoto photo) {

		this.mPhoto = photo;
		this.mContext = context;
		this.mViewGroup = viewGroup;
	} 

	// Decode image in background.
	@Override
	protected Object doInBackground(Object... params) {
		InputStream is;
		try {
			is =  mContext.getContentResolver().openInputStream(Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mPhoto.id));
			Bitmap bitmap =  BitmapFactory.decodeStream(is);
			return(bitmap);
		} catch (FileNotFoundException e) {
			mContext.getContentResolver().registerContentObserver(Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mPhoto.id), 
					 false, new PhotoContentObserver(mContext, mViewGroup, mHandler, mPhoto.id));
			return null;
		}
	}

	// Once complete, see if ImageView is still around and set bitmap.
	@Override
	protected void onPostExecute(Object bitmap) {
			if ( bitmap != null) {
			ImageView imageViewByTag = (ImageView) mViewGroup.findViewWithTag(mPhoto.id);
			if (imageViewByTag != null) {
				imageViewByTag.setImageBitmap((Bitmap) bitmap);
			}
		}
	}

}
class PhotoContentObserver extends ContentObserver { 
	String mId;
	Context mContext;
	ViewGroup mViewGroup;
	
	public PhotoContentObserver(Context context, ViewGroup viewGroup, Handler handler, String id) { 
		super(handler); 
		mId = id;
		mContext = context;
		this.mViewGroup = viewGroup;
	}

	@Override
	public void onChange(boolean selfChange) {
		InputStream is;
		try {
			is = mContext.getContentResolver().openInputStream(Uri.withAppendedPath(FlickrPhotoProvider.CONTENT_URI ,mId));
			Bitmap bitmap =  BitmapFactory.decodeStream(is);
			ImageView imageViewByTag = (ImageView) mViewGroup.findViewWithTag(mId);
			if (imageViewByTag != null) {
				imageViewByTag.setImageBitmap(bitmap);
			}	 
		} catch (FileNotFoundException e) {
		}
	}
}