package com.bffmedia.hour18app;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.Menu;
import android.widget.TextView;

public class MainActivity extends Activity {
	TextView mDisplayTextView;
	LocationManager mLocationManager;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		mLocationManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
		Location lastGPSLocation = mLocationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
		logLocation(lastGPSLocation);
		Location lastLocation =  getRecentLocation(); 
		logLocation(lastLocation);
		// Use provider from lastLocation to track changes
		mLocationManager.requestLocationUpdates(lastLocation.getProvider(), 0, 0, locationListener);		
		//Use GPS_PROVIDER
//		if (mLocationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)){
//			mLocationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, locationListener);
//		}
		//Use Criteria from getProvider() method
//		mLocationManager.requestLocationUpdates(getProvider(), 0, 0, locationListener);

		mDisplayTextView = (TextView) findViewById(R.id.displayTextView);
		
		Geocoder coder = new Geocoder(getApplicationContext());
		String locationToFind = "White Plains, NY";
		List<Address> geocodeResults;
		try {
			geocodeResults = coder.getFromLocationName(locationToFind, 3);
			for (Address address: geocodeResults){
				Log.d("Location", locationToFind + " " + address.getLatitude() +"," + address.getLongitude());
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

	}
	protected void onStop() {
	    super.onStop();
	    mLocationManager.removeUpdates(locationListener);
	}
	LocationListener locationListener = new LocationListener() {
		@Override
		public void onLocationChanged(Location location) {
			Geocoder coder = new Geocoder(getApplicationContext());
			List<Address> geocodeResults;
			try {
				geocodeResults = coder.getFromLocation(location.getLatitude(), location.getLongitude(), 1);
				for (Address address: geocodeResults){
					Log.d("Location", location.getLatitude() +"," + location.getLongitude() +" : " +address.getLocality());
					mDisplayTextView.setText(location.getLatitude() +"," + location.getLongitude()+" : " +address.getLocality());
				}
				String geoURI = "geo:" + location.getLatitude() +"," + location.getLongitude() ;
				Uri geo = Uri.parse(geoURI);
				Intent geoMap = new Intent(Intent.ACTION_VIEW, geo);
				startActivity(geoMap);

			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		@Override
		public void onProviderDisabled(String provider) {}
		@Override
		public void onProviderEnabled(String provider) {}
		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) {}
	};
	
	public String getProvider(){
		Criteria criteria = new Criteria();
		criteria.setAccuracy(Criteria.ACCURACY_FINE);
		criteria.setSpeedRequired(true);
		String providerName = mLocationManager.getBestProvider(criteria, true);
		if (providerName != null) {
			return providerName;
		}else{
			return LocationManager.GPS_PROVIDER;
		}
	}
	public Location getRecentLocation() {
	    Location recentLocation = null;
	    long bestTime = 0;
	    List<String> matchingProviders = mLocationManager.getAllProviders();
	    for (String provider: matchingProviders) {
	      Location location = mLocationManager.getLastKnownLocation(provider);
	      if (location != null) {
	        long time = location.getTime();
	        if (time > bestTime) {
	          bestTime = time;
	          recentLocation = location;
	        }
	      }
	    }
	    return recentLocation;
	}
	private void logLocation (Location location){
		Date lastDate=new Date(location.getTime());
		Log.d("Location", "last: " + location.getLatitude() +"," + location.getLongitude()+ " from "+ location.getProvider()+" at " + lastDate.getHours()+ ":" + lastDate.getMinutes());
	}
}
