package com.bffmedia.hour18appplay;

import java.io.IOException;
import java.util.Date;
import java.util.List;

import android.app.Activity;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.location.LocationClient;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;

public class MainActivity extends Activity  implements  LocationListener,
GooglePlayServicesClient.ConnectionCallbacks,
GooglePlayServicesClient.OnConnectionFailedListener  {
	TextView mDisplayTextView;
	
     LocationRequest mLocationRequest;
     LocationClient mLocationClient;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		mDisplayTextView = (TextView) findViewById(R.id.displayTextView);
        mLocationRequest = LocationRequest.create();
        mLocationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
        mLocationClient = new LocationClient(this, this, this);
	}
	
	@Override
    public void onStart() {

        super.onStart();
        int googlePayResult = GooglePlayServicesUtil.isGooglePlayServicesAvailable(this);
        if (googlePayResult == ConnectionResult.SUCCESS ) {
        	mLocationClient.connect();
        }else{
			Toast.makeText(this, "Google Play is not Available", Toast.LENGTH_LONG).show();
        }
    }

	
	protected void onStop() {
	    super.onStop();
        mLocationClient.removeLocationUpdates(this);
        mLocationClient.disconnect();
	}


	private void logLocation (Location location){
		Date lastDate=new Date(location.getTime());
		Log.d("Location", "last: " + location.getLatitude() +"," + location.getLongitude()+ " from "+ location.getProvider()+" at " + lastDate.getHours()+ ":" + lastDate.getMinutes());
	}
	@Override
	public void onConnectionFailed(ConnectionResult arg0) {
		
	}
	@Override
	public void onConnected(Bundle connectionHint) {
	    mLocationClient.requestLocationUpdates(mLocationRequest, this);
	    mDisplayTextView.setText("Connected");
		
	}
	@Override
	public void onDisconnected() {
		
	}
	@Override
	public void onLocationChanged(Location location) {
        Geocoder coder = new Geocoder(getApplicationContext());
		List<Address> geocodeResults;
		try {
			geocodeResults = coder.getFromLocation(location.getLatitude(), location.getLongitude(), 1);
			for (Address address: geocodeResults){
				Log.d("Location", location.getLatitude() +"," + location.getLongitude() +" : " +address.getLocality());
				mDisplayTextView.setText(location.getLatitude() +"," + location.getLongitude()+" : " +address.getLocality());
			}

		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
}
