package com.bffmedia.hour21imageview;




import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageView;
import android.widget.RadioButton;

public class MainActivity extends Activity {
//	Matrix matrix;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		final ImageView imageView = (ImageView) findViewById(R.id.imageView1);

		RadioButton center = (RadioButton) findViewById(R.id.radioCenter);
		RadioButton centerCrop = (RadioButton) findViewById(R.id.radioCenterCrop);
		RadioButton centerInside = (RadioButton) findViewById(R.id.radioCenterInside);
		
		
		RadioButton fitCenter = (RadioButton) findViewById(R.id.radioFitCenter);
		RadioButton fitStart = (RadioButton) findViewById(R.id.radioFitStart);
		RadioButton fitEnd = (RadioButton) findViewById(R.id.radioFitEnd);
		RadioButton fitXY = (RadioButton) findViewById(R.id.radioFitXY);

		Button rotate = (Button) findViewById(R.id.buttonRotate);
		Button draw = (Button) findViewById(R.id.buttonDraw);
		
		
		
		
		center.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.CENTER);
				}
			}
          });
		
		centerCrop.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.CENTER_CROP);
				}
			}
          });
		
		centerInside.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.CENTER_INSIDE);
				}
			}
          });
		
		fitCenter.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.FIT_CENTER);
				}
			}
          });
		
		fitStart.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.FIT_START);
				}
			}
          });
		
		fitEnd.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.FIT_END);
				}
			}
          });
		
		fitXY.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked){
					imageView.setScaleType(ImageView.ScaleType.FIT_XY);
				}
			}
          });
		
		
		
		rotate.setOnClickListener(new OnClickListener() {
    		public void onClick(View v) {
//    			imageView.setPivotX(imageView.getWidth()/2);
//    			imageView.setPivotY(imageView.getHeight()/2);
//    			imageView.setRotation(30);
    			Matrix matrix = imageView.getImageMatrix();
    			imageView.setScaleType(ImageView.ScaleType.MATRIX);
    			matrix.postRotate(30, imageView.getWidth()/2, imageView.getHeight()/2);
    			imageView.setImageMatrix(matrix);  
    		}
    	});
		
		draw.setOnClickListener(new OnClickListener() {
    		public void onClick(View v) {
    			Bitmap imageBitmap = Bitmap.createBitmap(imageView.getWidth(), imageView.getHeight(), Bitmap.Config.ARGB_8888);
        		Canvas canvas = new Canvas(imageBitmap);
        		float scale = getResources().getDisplayMetrics().density;
        		Paint p = new Paint();
        		p.setColor(Color.BLUE);
        		p.setTextSize(24*scale);
        		canvas.drawText("Hello", imageView.getWidth()/2,imageView.getHeight()/2, p);
        		imageView.setImageBitmap(imageBitmap);
    		}
    	});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

}
