package com.example.hour21presentation;

import android.hardware.display.DisplayManager;
import android.media.MediaRouter;
import android.os.Bundle;
import android.app.Activity;
import android.app.Presentation;
import android.content.Context;
import android.view.Display;
import android.view.Menu;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		DisplayManager displayManager = (DisplayManager) this.getSystemService(Context.DISPLAY_SERVICE);
		 Display[] presentationDisplays = displayManager.getDisplays(DisplayManager.DISPLAY_CATEGORY_PRESENTATION);
		 System.out.println("Num Displays: " + presentationDisplays.length);
		 if (presentationDisplays.length > 0) {
			 
		     // If there is more than one suitable presentation display, then we could consider
		     // giving the user a choice.  For this example, we simply choose the first display
		     // which is the one the system recommends as the preferred presentation display.
		     Display display = presentationDisplays[0];
		     Presentation presentation = new DemoPresentation(this, display);
		     presentation.show();
		 }
		
		 MediaRouter mediaRouter = (MediaRouter) this.getSystemService(Context.MEDIA_ROUTER_SERVICE);
		 MediaRouter.RouteInfo route = mediaRouter.getSelectedRoute(MediaRouter.ROUTE_TYPE_LIVE_VIDEO);
		 if (route != null) {
			 System.out.println("Route detected");

		     Display display = route.getPresentationDisplay();
		     if (display != null) {
			     Presentation presentation = new DemoPresentation(this, display);
		         presentation.show();
		     }
		 }
		 
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}
	
	
	private final static class DemoPresentation extends Presentation {
       
        public DemoPresentation(Context context, Display display) {
            super(context, display);
        }

        @Override
        protected void onCreate(Bundle savedInstanceState) {
            // Be sure to call the super class.
            super.onCreate(savedInstanceState);
            setContentView(R.layout.activity_main);
           
        }

       
    }

	

}
