package com.bffmedia.hour23opensource;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import org.json.JSONException;



import android.app.IntentService;
import android.content.ContentValues;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.SystemClock;
import android.util.Log;

public class FlickrService extends IntentService {
	public final static String API_KEY ="PUT_YOUR_API_KEY_HERE";
	public final static String NUM_PHOTOS ="12";

	public FlickrService() {
		super("FlickrService");
	}
	@Override
	protected void onHandleIntent(Intent intent) {
		SystemClock.sleep(5000); 
		HttpURLConnection connection = null;
		try {
			URL dataUrl = new URL("http://api.flickr.com/services/rest/?method=flickr.photos.getRecent&api_key="+ API_KEY+ "&per_page=" + NUM_PHOTOS +"&format=json&nojsoncallback=1");
			connection = (HttpURLConnection) dataUrl.openConnection();
			connection.connect();
			int status = connection.getResponseCode();
			Log.d("connection", "status " + status);
			if (status ==200){
			  InputStream is = connection.getInputStream();
			  BufferedReader reader = new BufferedReader(new InputStreamReader(is));
			  String responseString;
			  StringBuilder sb = new StringBuilder();
			  while ((responseString = reader.readLine()) != null) {
				  sb = sb.append(responseString);
			  }
			  String photoData = sb.toString();
			  Intent broadcastIntent = new Intent();
				broadcastIntent.putExtra("photoData", photoData);
				broadcastIntent.setAction("com.bffmedia.hour23opensource.PHOTODATA");
				sendBroadcast(broadcastIntent);
			}
		}
		catch (IOException e) {
			System.out.println("IOException");
			e.printStackTrace();
		} finally {
			connection.disconnect();
		}
		
	}
}

