package com.bffmedia.hour23opensource;



import static com.nineoldandroids.view.ViewPropertyAnimator.animate;

import java.util.ArrayList;

import org.json.JSONException;

import com.actionbarsherlock.app.SherlockFragmentActivity;


import android.os.Bundle;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.view.PagerTabStrip;
import android.support.v4.view.ViewPager;
import android.view.View;
import android.widget.TextView;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuItem;


public class MainActivity extends SherlockFragmentActivity {
	PhotoReceiver mPhotoReceiver = new PhotoReceiver();
	private ArrayList<FlickrPhoto> mPhotos = new ArrayList<FlickrPhoto>();
	 ViewPager mViewPager;
	 PagerTabStrip mPagerTabStrip;
	 TextView mTextView;
//	 ;



	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		mViewPager=(ViewPager)findViewById(R.id.viewPager);
		mPagerTabStrip =(PagerTabStrip)findViewById(R.id.pagerTabStrip);
		mTextView = (TextView)findViewById(R.id.textView1);
		
    	animate(mTextView).setDuration(5000).rotationYBy(720);

		
		
		Intent photoIntent = new Intent(MainActivity.this, FlickrService.class);
		
		
		startService(photoIntent);

	}

	@Override
	protected void onResume (){
		super.onResume();
		registerReceiver(mPhotoReceiver, new IntentFilter("com.bffmedia.hour23opensource.PHOTODATA"));
	}
	
	protected void onPause (){
		super.onPause();
		unregisterReceiver(mPhotoReceiver);
	}


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		  menu.add("Menu 1")
          .setShowAsAction(MenuItem.SHOW_AS_ACTION_IF_ROOM);

      menu.add("Menu 2")
          .setShowAsAction(MenuItem.SHOW_AS_ACTION_IF_ROOM | MenuItem.SHOW_AS_ACTION_WITH_TEXT);

      menu.add("Menu 3")
          .setShowAsAction(MenuItem.SHOW_AS_ACTION_IF_ROOM | MenuItem.SHOW_AS_ACTION_WITH_TEXT);		return true;
	}
	public String getImageUrlByPosition(int position){
		return mPhotos.get(position).getPhotoUrl(true);
	}
	
	public String getImageTitlePosition(int position){
		return mPhotos.get(position).title;
	}

	public class PhotoReceiver extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			String photoData = intent.getExtras().getString("photoData");
			try {
				mPhotos = FlickrPhoto.makePhotoList(photoData);
				 mViewPager.setAdapter(new ImageAdapter(MainActivity.this, getSupportFragmentManager()));
				 mPagerTabStrip.setVisibility(View.VISIBLE);
				 mTextView.setVisibility(View.GONE);
			} catch (NullPointerException e) {
				e.printStackTrace();
			} catch (JSONException e) {
				e.printStackTrace();
			}
		}
	}
	public class ImageAdapter extends FragmentPagerAdapter {
		Context mContext;
		  public ImageAdapter(Context context, FragmentManager fragmentManager) {
			super(fragmentManager);
			this.mContext = context;
		}

		  @Override
		  public int getCount() {
		    return mPhotos.size();
		  }

		  @Override
		  public Fragment getItem(int position) {
		    return(ImageFragment.newInstance(position));
		  }

		  @Override
		  public String getPageTitle(int position) {
		    return(mPhotos.get(position).title);
		  }
		}
	


}
