package com.bffmedia.hour7actionbarapp;

import com.bffmedia.hour7actionbarapp.R;

import android.os.Bundle;
import android.app.ActionBar;
import android.app.Activity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ArrayAdapter;
import android.widget.Toast;

public class MainActivity extends Activity {
	String[] values = {"One", "Two", "Three", "One Hundred" };
	ArrayAdapter<String> mSpinnerAdapter;
	NavigationListener mNavigationListener = new NavigationListener();
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		ActionBar actionBar = getActionBar();
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_LIST);
	
		
		mSpinnerAdapter = new ArrayAdapter<String>(this,R.layout.navigation_item, values); 
		actionBar.setListNavigationCallbacks(mSpinnerAdapter, mNavigationListener);
	}

	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		Toast toast = Toast.makeText(getApplicationContext(), "Option 1" , Toast.LENGTH_SHORT);
		switch (item.getItemId()) {
		case R.id.menu_item_1:
			toast.setText("Option 1");
			toast.show();
			return true;
		case R.id.menu_item_2:
			toast.setText("Option 2");
			toast.show();
			return true;
		case R.id.menu_item_3:
			toast.setText("Option 3");
			toast.show();
			return true;
		case R.id.menu_item_4:
			toast.setText("Option 4");
			toast.show();
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}	
	}

	private class NavigationListener implements ActionBar.OnNavigationListener{
		@Override
		public boolean onNavigationItemSelected(int position, long itemId) {
			String selected = values[position];
			Toast toast = Toast.makeText(getApplicationContext(), selected , Toast.LENGTH_SHORT);
			toast.show();
			return false;
		}
	}



}
