package com.bffmedia.hour8app.tab;

import com.bffmedia.hour8app.tab.R;

import android.app.ActionBar;
import android.app.Activity;
import android.app.FragmentTransaction;
import android.app.ActionBar.Tab;
import android.os.Bundle;

import android.view.Menu;
import android.widget.Toast;

public class MainActivity extends Activity {


	Tab mTab1;
	Tab mTab2;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		ActionBar actionBar = getActionBar();		
		actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
		mTab1= actionBar.newTab().setText("Fragment A").setTabListener(new NavTabListener());
		mTab2= actionBar.newTab().setText("Fragment B").setTabListener(new NavTabListener());
		actionBar.addTab(mTab1);
		actionBar.addTab(mTab2);

		
		showFragmentA();
		}
	
	public void showFragmentA(){
		FragmentA fragmentA = new FragmentA();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentA);
		ft.addToBackStack("fragment a");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	

	}
	
	public void showFragmentB(){
		FragmentB fragmentB = new FragmentB();
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		ft.replace(R.id.layout_container, fragmentB);
		ft.addToBackStack("fragment b");
		ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
		ft.commit();
	}


	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}
	
	private class NavTabListener implements ActionBar.TabListener {
		public NavTabListener() {
		}
		@Override
		public void onTabReselected(Tab tab, FragmentTransaction ft) {
		}
		@Override
		public void onTabSelected(Tab tab, FragmentTransaction ft) {
			if (tab.equals(mTab1)){
				showFragmentA();
			}else{
				showFragmentB();
			}
		}
		@Override
		public void onTabUnselected(Tab tab, FragmentTransaction ft) {
		}
	}

}
