package com.bffmedia.hour23;


import android.os.Bundle;
import android.os.SystemClock;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.TransitionDrawable;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import com.nineoldandroids.animation.*;
import static com.nineoldandroids.view.ViewPropertyAnimator.animate;

public class MainActivity extends Activity {
	TextView mDisplay;
	DelayReceiver mDelayReceiver = new DelayReceiver();
	Button runIntentServiceButton;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		mDisplay = (TextView) findViewById(R.id.displayTextView);
    	runIntentServiceButton = (Button) findViewById(R.id.intentServiceButton);
    	runIntentServiceButton.setOnClickListener(new OnClickListener() {
    		public void onClick(View v) {
    			Intent delayIntent = new Intent(MainActivity.this, FiveSecondService.class);
    			startService(delayIntent);
    		}
    	});
    	
    	Button doNotRunIntentServiceButton = (Button) findViewById(R.id.noIntentServiceButton);
    	animate(doNotRunIntentServiceButton).setDuration(2000).rotationYBy(720);
    	doNotRunIntentServiceButton.setOnClickListener(new OnClickListener() {
    		public void onClick(View v) {
    			   SystemClock.sleep(5000); 
    			   Intent broadcastIntent = new Intent();
                   broadcastIntent.putExtra("message", "UPDATE: NO INTENT SERVICE");
				   broadcastIntent.setAction("com.bffmedia.hour23.DELAY");
                   MainActivity.this.sendBroadcast(broadcastIntent);    			
    		}
    	});
    	
    
	}
	
	@Override
	protected void onResume (){
		super.onResume();
		registerReceiver(mDelayReceiver, new IntentFilter("com.bffmedia.hour23.DELAY"));
		
		
		AnimatorSet set = new AnimatorSet();
		set.playTogether(
		    ObjectAnimator.ofFloat(runIntentServiceButton, "scaleX", 1, 1.5f,1),
		    ObjectAnimator.ofFloat(runIntentServiceButton, "scaleY", 1, 1.5f,1),
		    ObjectAnimator.ofFloat(runIntentServiceButton, "alpha", 1, 0.25f, 1)
		);
		set.setDuration(5 * 1000).start();
		
		
	}
	
	protected void onPause (){
		super.onPause();
		unregisterReceiver(mDelayReceiver);
	}
	

	public class DelayReceiver extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			String message = intent.getExtras().getString("message");
			mDisplay.setText("Finished " + message);
		}
	}
	
}
